use std::fs::File;
use std::io::{self, BufRead};
use std::path::Path;

pub fn part_two() {
    if let Ok(lines) = read_lines("./input.txt") {
        let mut race_result: Vec<u64> = Vec::new();

        for line in lines {
            race_result.push(process_line(&line.unwrap()));
        }

        let win_count = process_race_result(race_result[0], race_result[1]);

        println!("{:?}", win_count);
    }
}

fn process_line(s: &str) -> u64 {
    let nums_str = s.split(':').collect::<Vec<&str>>()[1]
        .split_whitespace()
        .collect::<Vec<&str>>()
        .concat();
    let num: u64 = nums_str.parse::<u64>().unwrap();

    return num;
}

fn process_race_result(time: u64, distance: u64) -> u64 {
    let mut win_count = 0;

    for i in 0..time {
        if i * (time - i) > distance {
            win_count += 1;
        }
    }

    return win_count;
}

fn read_lines<P>(filename: P) -> io::Result<io::Lines<io::BufReader<File>>>
where
    P: AsRef<Path>,
{
    let file = File::open(filename)?;
    Ok(io::BufReader::new(file).lines())
}
